﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using AMESRestful.Models;
using System.IO;


namespace AMESRestful.Controllers
{
    public class ErrorCodeController : ApiController
    {
        static private TagValues cmTagValues;
        // GET: api/ErrorCode
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        // GET: api/ErrorCode/5
        public string Get(int id)
        {
            return "value";
        }

        public HttpResponseMessage Post([FromBody]string value)
        {
            cmTagValues = new TagValues();

            string dirPath = @"C:\Logs";
            if (Directory.Exists(dirPath))
            {
                //Console.WriteLine("The directory {0} already exists.", dirPath);
            }
            else
            {
                Directory.CreateDirectory(dirPath);
                Console.WriteLine("The directory {0} was created.", dirPath);
            }

            string sRecordStr = value;
            sRecordStr = DateTime.Now.ToString() + " " + cmTagValues.fnCleanInput(value);
            cmTagValues.fnMESDataRecodWrite("C:\\Logs\\AMESRestfulReceive_ErrCode.csv", sRecordStr.Trim().ToUpper());
            Console.Write(DateTime.Now.ToString() + " Data Record");

            #region
            string controllerName = ControllerContext.RouteData.Values["controller"].ToString();
            JObject jo = JObject.Parse(value.ToUpper().Trim());
            string MESTagName = jo["TAGNAME"].ToString();

            //解第一層
            string Layer_1 = jo["TAGINFO"].ToString();
            JArray ja = (JArray)JsonConvert.DeserializeObject(Layer_1);

            string[] arrTagValue = new string[ja.Count];
            //string jtPara1 = "";
            string jtPara2 = "";
            string[] InfoType = {"ERR_CODE"};
            for (int i = 0; i < ja.Count; i++)
            {
                //jtPara1 = "TagInfo[" + InfoType[i] + "]";
                jtPara2 = "TAGINFO[0]." + InfoType[i];
                JToken jtValueTmp = null;
                jtValueTmp = jo.SelectToken(jtPara2);
                if (jtValueTmp != null)
                {
                    arrTagValue[i] = jtValueTmp.ToString();
                }
                else
                {
                    arrTagValue[i] = "";
                }
            }

            var result = new
            {
                TagName = MESTagName,
                //ID = id,
                TagsCount = ja.Count,
                //QC = TagValues.myQueue.Count,

                TagInfo_0 = arrTagValue[0],
               
                STATUS = true,
                MSG = "success",

            };

            fnDataTranslate(arrTagValue, MESTagName);
            return Request.CreateResponse(HttpStatusCode.OK, result);

            #endregion;
        }

        // PUT: api/ErrorCode/5
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE: api/ErrorCode/5
        public void Delete(int id)
        {
        }

        private void fnDataTranslate(string[] InputArray, string Device)
        {
            try
            {
                string sendBody = "{\"Tags\":[";

                for (int i = 0; i < InputArray.Length; i++)
                {
                    //if (i != 6)
                    {
                        //sendBody += "{\"Name\":\"" + InputArray[0].Trim() + "_M2_P(" + i.ToString() + ")\",\"Value\":\"" + InputArray[i] + "\"}";
                        sendBody += "{\"Name\":\"" + Device + "\",\"Value\":\"" + InputArray[i] + "\"}";
                        //20181123
                        //SetupIni.IniWriteValue("TagValueRecord", sLineID.Trim() + "_M1_Tag01(" + i.ToString() + ")", tmpTextBox.Text);

                        if (i != InputArray.Length - 1)
                        {
                            sendBody += ", ";
                        }
                    }
                }
                sendBody += "]}";
                cmTagValues.fnQuePush(sendBody, Device, InputArray, 1);

            }
            catch
            {

            }
        }
    }
}
