﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using AMESRestful.Models;
using System.Threading;
using System.IO;

namespace AMESRestful.Controllers
{
    public class Analysis_elments
    {
        public string elment_Name { get; set; } 
        public string[] elment_Array { get; set; } 
    }

    public class MESInfo_AController : ApiController
    {
        static private TagValues cmTagValues;
        // GET: api/MESInfo_A
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        // GET: api/MESInfo_A/5
        public string Get(int id)
        {
            return "value";
        }

        // POST: api/MESInfo_A
        public HttpResponseMessage Post([FromBody]string value)
        {
            cmTagValues = new TagValues();

            string dirPath = @"C:\Logs";
            if (Directory.Exists(dirPath))
            {
                //Console.WriteLine("The directory {0} already exists.", dirPath);
            }
            else
            {
                Directory.CreateDirectory(dirPath);
                Console.WriteLine("The directory {0} was created.", dirPath);
            }

            string sRecordStr = value;
            sRecordStr =DateTime.Now.ToString()+" "+ cmTagValues.fnCleanInput(value);
            cmTagValues.fnMESDataRecodWrite("C:\\Logs\\AMESRestfulReceive_A.csv", sRecordStr.Trim().ToUpper());
            Console.Write(DateTime.Now.ToString() + " Data Record");
                  
            #region

            //string controllerName = ControllerContext.RouteData.Values["controller"].ToString();

            JObject jo = JObject.Parse(value.ToUpper().Trim());

            Analysis_elments TagElments = new Analysis_elments();
            TagElments = fnTagAnalysis(jo);
            

            string ini_prj = TagValues.TagValues_ini.ProjName;
            string ini_node = TagValues.TagValues_ini.NodeName;
            string ini_id = TagValues.TagValues_ini.UserName;
            string ini_pw = TagValues.TagValues_ini.Password;
            string ini_auth = TagValues.TagValues_ini.BasicAuth;

            var result = new
            {
                TagName = TagElments.elment_Name,
                //ID = id,
                //TagsCount = ja.Count,
                Queue_Counts = TagValues.myQueue.Count,

                TagInfo_0 = TagElments.elment_Array[0],
                TagInfo_1 = TagElments.elment_Array[1],
                TagInfo_2 = TagElments.elment_Array[2],
                TagInfo_3 = TagElments.elment_Array[3],
                TagInfo_4 = TagElments.elment_Array[4],
                TagInfo_5 = TagElments.elment_Array[5],
                TagInfo_6 = TagElments.elment_Array[6],
                TagInfo_7 = TagElments.elment_Array[7],
                TagInfo_8 = TagElments.elment_Array[8],
                TagInfo_9 = TagElments.elment_Array[9],

                authToken = ini_auth,
                prj = ini_prj,
                node = ini_node,
                id = ini_id,
                pw = ini_pw,

                STATUS = true,
                MSG = "success",
            };

            fnDataTranslate(TagElments.elment_Array, TagElments.elment_Name);
                      
            return Request.CreateResponse(HttpStatusCode.OK,result);
            #endregion;
        }
        private void fnDataTranslate(string[] InputArray, string Device)
        {
            try
            {
                string sendBody = "{\"Tags\":[";

                for (int i = 0; i < InputArray.Length; i++)
                {
                    //if (i != 6)
                    {
                        //sendBody += "{\"Name\":\"" + InputArray[0].Trim() + "_M2_P(" + i.ToString() + ")\",\"Value\":\"" + InputArray[i] + "\"}";
                        sendBody += "{\"Name\":\"" + Device + "(" + i.ToString() + ")\",\"Value\":\"" + InputArray[i] + "\"}";
                        //20181123
                        //SetupIni.IniWriteValue("TagValueRecord", sLineID.Trim() + "_M1_Tag01(" + i.ToString() + ")", tmpTextBox.Text);

                        if (i != InputArray.Length - 1)
                        {
                            sendBody += ", ";
                        }
                    }
                }
                sendBody += "]}";
                cmTagValues.fnQuePush(sendBody, Device, InputArray, 0);
            }
            catch
            {

            }
        }

        private Analysis_elments fnTagAnalysis(JObject jo)
        {   
            try
            {
                Analysis_elments Analysis_result = new Analysis_elments();

                string MESTagName = jo["TAGNAME"].ToString();
                //解第一層
                string Layer_1 = jo["TAGINFO"].ToString();
                JArray ja = (JArray)JsonConvert.DeserializeObject(Layer_1);

                string[] arrTagValue = new string[10];
                //string jtPara1 = "";
                string jtPara2 = "";
                string[] InfoType = { "UPLOAD_TYPE", "LINE_DESC", "WIP_NO", "PN", "LOT", "PLAN_QTY", "SIDE", "START_TIME", "END_TIME", "STD_WORK_TIME" };

                for (int i = 0; i < 10; i++)
                {

                    //jtPara1 = "TagInfo[" + InfoType[i] + "]";
                    jtPara2 = "TAGINFO[0]." + InfoType[i];
                    JToken jtValueTmp = null;
                    jtValueTmp = jo.SelectToken(jtPara2);
                    if (jtValueTmp != null)
                    {
                        if (i == 7 || i == 8)
                        {
                            if (jtValueTmp.ToString() != string.Empty)
                            {
                                arrTagValue[i] = DateTime.Parse(jtValueTmp.ToString()).ToString("o") + "+08:00";
                            }
                            else
                            {
                                arrTagValue[i] = "";
                            }
                        }
                        else
                        {
                            arrTagValue[i] = jtValueTmp.ToString();
                        }
                    }
                    else
                    {
                        arrTagValue[i] = "";
                    }
                }

                Analysis_result.elment_Name = MESTagName;
                Analysis_result.elment_Array = arrTagValue;

                return Analysis_result;
            }
            catch
            {
                return null;
            }
        }

        // POST: api/MESInfo_A/5
        public HttpResponseMessage Post(string id, [FromBody]JObject value)
        {
            if (id.ToUpper() == "JSON")
            {
                cmTagValues = new TagValues();

                string dirPath = @"C:\Logs";
                if (Directory.Exists(dirPath))
                {
                    //Console.WriteLine("The directory {0} already exists.", dirPath);
                }
                else
                {
                    Directory.CreateDirectory(dirPath);
                    Console.WriteLine("The directory {0} was created.", dirPath);
                }

                string sRecordStr = value.ToString();
                sRecordStr = DateTime.Now.ToString() + " " + cmTagValues.fnCleanInput(value.ToString());
                cmTagValues.fnMESDataRecodWrite("C:\\Logs\\AMESRestfulReceive_A.csv", sRecordStr.Trim().ToUpper());
                Console.Write(DateTime.Now.ToString() + " Data Record");

                #region

                JObject jo = JObject.Parse(value.ToString().ToUpper().Trim());

                Analysis_elments TagElments = new Analysis_elments();
                TagElments = fnTagAnalysis(jo);

                string ini_prj = TagValues.TagValues_ini.ProjName;
                string ini_node = TagValues.TagValues_ini.NodeName;
                string ini_id = TagValues.TagValues_ini.UserName;
                string ini_pw = TagValues.TagValues_ini.Password;
                string ini_auth = TagValues.TagValues_ini.BasicAuth;

                var result = new
                {
                    TagName = TagElments.elment_Name,
                    //ID = id,
                    //TagsCount = ja.Count,
                    Queue_Counts = TagValues.myQueue.Count,

                    TagInfo_0 = TagElments.elment_Array[0],
                    TagInfo_1 = TagElments.elment_Array[1],
                    TagInfo_2 = TagElments.elment_Array[2],
                    TagInfo_3 = TagElments.elment_Array[3],
                    TagInfo_4 = TagElments.elment_Array[4],
                    TagInfo_5 = TagElments.elment_Array[5],
                    TagInfo_6 = TagElments.elment_Array[6],
                    TagInfo_7 = TagElments.elment_Array[7],
                    TagInfo_8 = TagElments.elment_Array[8],
                    TagInfo_9 = TagElments.elment_Array[9],

                    authToken = ini_auth,
                    prj = ini_prj,
                    node = ini_node,
                    id = ini_id,
                    pw = ini_pw,

                    STATUS = true,
                    MSG = "success",
                };

                fnDataTranslate(TagElments.elment_Array, TagElments.elment_Name);

                return Request.CreateResponse(HttpStatusCode.OK, result);
                #endregion;


            }
            else
            {
                var result = new
                {
                    STATUS = false,
                    MSG = "fail",
                };
                return Request.CreateResponse(HttpStatusCode.BadGateway, result);
            }

        }

        // PUT: api/MESInfo_A/5
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE: api/MESInfo_A/5
        public void Delete(int id)
        {
        }
    }
}
