﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using AMESRestful.Models;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Reflection;   

namespace AMESRestful.Controllers
{
    public class MESInfo_QController : ApiController
    {
        static private TagValues cmTagValues;
        // GET: api/MESInfo_Q
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        // GET: api/MESInfo_Q/5
        public string Get(int id)
        {
            return "value";
        }

        // POST: api/MESInfo_Q
        public HttpResponseMessage Post([FromBody]string value)
        {
            cmTagValues = new TagValues();

            string dirPath = @"C:\Logs";
            if (Directory.Exists(dirPath))
            {
                //Console.WriteLine("The directory {0} already exists.", dirPath);
            }
            else
            {
                Directory.CreateDirectory(dirPath);
                Console.WriteLine("The directory {0} was created.", dirPath);
            }

            string sRecordStr = value;
            sRecordStr = DateTime.Now.ToString() + " " + cmTagValues.fnCleanInput(value);
            cmTagValues.fnMESDataRecodWrite("C:\\Logs\\AMESRestfulReceive_Q.csv", sRecordStr.Trim().ToUpper()); 
            Console.Write(DateTime.Now.ToString() + " Data Record");
          
            #region
            string controllerName = ControllerContext.RouteData.Values["controller"].ToString();
            JObject jo = JObject.Parse(value.ToUpper().Trim());
            string MESTagName = jo["TAGNAME"].ToString() + "(";
            
            //解第一層
            string Layer_1 = jo["TAGINFO"].ToString();
            JArray ja = (JArray)JsonConvert.DeserializeObject(Layer_1);

            string[] arrTagValue = new string[7];
            //string jtPara1 = "";
            string jtPara2 = "";
            string[] InfoType = { "LINE_DESC", "WIP_NO", "PN", "LOT", "SIDE", "TOTAL_QTY", "FAIL_QTY" };
            for (int i = 0; i < 7; i++)
            {
                //jtPara1 = "TagInfo[" + InfoType[i] + "]";
                jtPara2 = "TAGINFO[0]." + InfoType[i];
                JToken jtValueTmp = null;
                jtValueTmp = jo.SelectToken(jtPara2);
                if (jtValueTmp != null)
                {
                    arrTagValue[i] = jtValueTmp.ToString();
                }
                else
                {
                    arrTagValue[i] = "";
                }
            }

            var result = new
            {
                //TagName = MESTagName,
                //ID = id,
                //TagsCount = ja.Count,
                //QC = TagValues.myQueue.Count,

                TagInfo_0 = arrTagValue[0],
                TagInfo_1 = arrTagValue[1],
                TagInfo_2 = arrTagValue[2],
                TagInfo_3 = arrTagValue[3],
                TagInfo_4 = arrTagValue[4],
                TagInfo_5 = arrTagValue[5],
                TagInfo_6 = arrTagValue[6],
                STATUS = true,
                MSG = "success",

            };

            fnDataTranslate(arrTagValue, MESTagName);
            return Request.CreateResponse(HttpStatusCode.OK, result);

            #endregion;
        }
        private void fnDataTranslate(string[] InputArray, string Device)
        {
            try
            {
                string sendBody = "{\"Tags\":[";
           
                for (int i = 0; i < InputArray.Length; i++)
                {
                    //if (i != 6)
                    {
                        //sendBody += "{\"Name\":\"" + InputArray[0].Trim() + "_M2_P(" + i.ToString() + ")\",\"Value\":\"" + InputArray[i] + "\"}";
                        sendBody += "{\"Name\":\"" + Device + i.ToString() + ")\",\"Value\":\"" + InputArray[i] + "\"}";
                        //20181123
                        //SetupIni.IniWriteValue("TagValueRecord", sLineID.Trim() + "_M1_Tag01(" + i.ToString() + ")", tmpTextBox.Text);

                        if (i != InputArray.Length - 1)
                        {
                            sendBody += ", ";
                        }
                    }
                }
                sendBody += "]}";
                cmTagValues.fnQuePush(sendBody, Device, InputArray, 0);

            }
            catch
            {

            }
        }
        // PUT: api/MESInfo_Q/5
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE: api/MESInfo_Q/5
        public void Delete(int id)
        {
        }
    }
}
